<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: editor/default_schemes.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: editor/default_schemes.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>function edit_scheme(json_schema, title)
{
  editor[title] = new JSONEditor(new_div,
    {
      schema : {
        "title": title,
        "type": "object",
        "items" : json_schema,
        "options": {
          "disable_array_delete": false,
          "disable_array_reorder": true
        }
      },
      required_by_default: false,
      display_required_only: true
    }
  )
}

/** collection of json schemes
* some functions for dynamic scheme creation
* @class
*/
function Schemes() {
  this.query = {
    "query":{
      "title":"query",
      "type":"object",
      "description":"Define targetet devices by mongodb query",
      "properties":{
        "target":{
          "required":true,
          "description":"find query to define what devices to address",
          "type":"string"
        },
        "message":{
          "required":true,
          "description":"what to send to targetet devices",
          "type":"object"
        }
      }
    }
  }
  this.cue = {
    "title": "Cue",
    "headerTemplate": "{{ i1 }} {{ self.path }} {{ self.name }}",
    "type": "object",
    "id": "a_cue",
    "definitions":{},
    "properties": {
      "name": {
        "required":true,
        "type": "string",
        "description": "Cue name",
        "propertyOrder": 1
      },
      "path": {
        "required":true,
        "readOnly":true,
        "type":"array",
        "options":{
          "hidden":true
        },
        "items":{
          "type":"string"
        }
      },
      "comment": {
        "type":"string",
        "propertyOrder": 2
      },
      "view": {
        "type": "object",
        "readOnly": true,
        "required": false,
        "options": {
          "hidden": true
        },
        "descripton": "settings for jointjs view of cue",
        "properties": {
          "id": {
            "type": "string"
          },
          "position": {
            "type": "object",
            "properties": {
              "x": {
                "type": "number"
              },
              "y": {
                "type": "number"
              }
            }
          },
          "style":{
            "type":"string",
            "propertyOrder": 3,
            "descripton":"add css style to the cue to give it the looks"
          },
        }
      }
    }
  }

  this.addChapter = function(name) {
    this.level.chapter.properties[name] = {
      "title":name,
      "type":"array",
      "format":"tabs",
      "items":this.cue
    }
  }

  this.chapter = {
    "title":"|",
    "type":"array",
    "format":"tabs",
    "items":this.cue
  }

  /**
  */
  this.level = {
    "_id": {
      "type":"string",
      "readonly":true
    },
    "name": {
      "type":"string",
      "required":true
    },
    "chapter": {
      "type":"object",
      //"format":"categories",
      //"basicCategoryTitle": "One",
      "properties":this.chapter
    },
    "config": {
      "type":"object",
      "properties":{
        "references":{
          "type":"array",
          "title":"Refered Documents",
          "default":[{"query":""}],
          "items":{
            "type":"object",
            "properties":{
              "name":{
                "type":"string",
                "required":true
              },
              "collection":{
                "type":"string",
                "required":true
              },
              "query":{
                "oneOf":[
                  {
                    "type":"string",
                    "required":true
                  },
                  {
                    "type":"object",
                    "required":true
                  }
                ]
              }
            }
          }
        },
        "player":{
          "title":"Player",
          "type":"array",
          "minItems":1,
          "items":{
            "type":"object",
            "properties":{
              "name":{
                "type":"string",
                "required":true,
                "description":"how to address role in cue editor"
              },
              "requirements":{
                "type":"array",
                "description":"describe what skills, scores, achievements etc. the player needs to have to play this level. Leave blank to allow access for all players",
                "items":{
                  "type":"string"
                }
              }
            }
          },
          "default":[{"name":"plyr"}]
        },
        "area":{
          "type":"number",
          "description":"Grander Location the level takes place.",
          "enum":[1, 2]
        },
        "maxSessions":{
          "type":"number",
          "description":"set maximum amount of sessions that should be created of this level at once.",
          "minimum":1
        },
        "agent":{
          "type":"string",
          "descripton":"what agent Phone to use by default"
        },
        "type":{
          "type":"string",
          "enum":["job","progress","unfinished","cooperative","meta"]
        },
        "language":{
          "required":true,
          "type":"string",
          "enum":["de","en"]
        },
        "priority":{
          "type":"number",
          "description":"If there are multiple jobs in stash for a player to play, those with a higher priority are prefered",
          "default":1
        },
        "family":{
          "type":"string",
          "description":"all level with same family are treated as the same level when assigning them to players, storing values etc."
        },
        "status":{
          "type":"string",
          "description":"Is the level being worked on etc."
        }
      }
    },
    "control": {
      "type":"object",
      "properties": {
        "pages":{
          "type":"object",
          "properties":{},
          "additionalProperties": {
            "type":"array",
            "items":{
              "type":"string"
            }
          }
        }
      }
    }
  }

  this.cuelist = []

  this.setCues = function(cues) {
    this.cuelist = []

    for(let chapter in cues) {
      for(let cue of cues[chapter]) {
        this.cuelist.push(chapter + '.' + cue.name)
      }
    }
    
    // removed because it conflicts once default cue properties are removed:
    /*
    this.cue.properties.dispatch.items['enum'] = this.cuelist
    this.cue.properties.listen.items.properties.followcue['enum'] = this.cuelist
    this.cue.properties.listen.items.properties.else['enum'] = this.cuelist
    this.level.control.properties.pages.properties = {}
    */
    for(let cue of this.cuelist) {
      this.level.control.properties.pages.properties[cue] = {
        "type":"array",
        "format":"table",
        "items":{
          "type":"string",
          "title":"cue",
          "enum":this.cuelist
        }
      }
    }
  }

  this.metaSchema = {
    "type":"object",
    "required":true,
    "description":"Define properties that can be changed by cues or that can be listened on",
    "additionalProperties":{
      "type":"object",
      "properties":{
        "type":{
          "type":"string",
          "enum":["object","string","number","boolean"]
        },
        "description":{
          "type":"string"
        },
        "enum":{
          "type":"array"
        },
        "properties":{
          "type":"object",
          "properties":{

          }
        }
      }
    }
  }

  this.setDevices = function(data) {
    this.devices = {}
    for(let device of data) {
      // console.log("Add Device properties")
      // console.log(device.properties)
      this.devices[device.name] = {"properties":{}}
      this.devices[device.name].properties = device.properties
    }
    // removed because it conflicts once default cue properties are removed:
    // this.cue.properties.send.items.properties = Object.assign(this.query, this.devices)
  }
  /**
  * Devices are user generated. The Object is being populated dynamically
  */
  this.devices = {}

  this.http = {
    "host":{
      "type":"string",
      "required":true,
      "description":"webaddress of device. Example:'localhost'"
    },
    "port":{
      "type":"number",
      "required":true,
      "default":8080,
      "description":"port the device can be reached at"
    },
    "method": {
      "type":"string",
      "description":"request routing method",
      "enum":["GET","POST"]
    },
    "path":{
      "type":"string",
      "description":"subaddress the device can be addressed by E.g: '/mydevice'"
    },
    "url":{
      "type":"string",
      "description":"if you set a url/uri host, port and path become obsolete"
    },
    "route":{
      "type":"string",
      "required":"true",
      //"template":"/{{route_name}}",
      "description":"route path, your device makes requests to the plai framework",
      "watch":{
        "route_name":"name"
      }
    }
  }

  this.udp = {
    "port":{
      "type":"number",
      "default":0,
      "required":true,
      "description":"port the device communicates with the plai framework on. 0 to set random port"
    },
    "ip":{
      "type":"string",
      "description":"the ip address of your device so the framework can send messages to it.",
      "default":"0.0.0.0"
    },
    "framework_port":{
      "type":"number",
      "description":"define a different port the device sends data to the framework on if needed."
    }
  }

  this.osc = {
    "port":{
      "type":"number",
      "default":0,
      "required":true,
      "description":"port the device communicates with the plai framework on. 0 to set random port"
    },
    "ip":{
      "type":"string",
      "description":"the ip address of your device so the framework can send messages to it.",
      "default":"0.0.0.0"
    },
    "framework_port":{
      "type":"number",
      "description":"define a different port the device sends data to the framework on if needed."
    },
    "path":{
      "type":"string",
      "descrption":"prepend an OSC formatted address for every message sent by OSC device"
    }
  }

  this.tcp = {
    "port":{
      "type":"number",
      "default":0,
      "required":true,
      "description":"port the device communicates with the plai framework on. 0 to set random port."
    },
    "ip":{
      "type":"string",
      "description":"the ip address of your device so the framework can send messages to it."
    },
    "framework_port":{
      "type":"number",
      "description":"define a different port the device sends data to the framework on if needed."
    }
  }

  this.serial = {
    "port":{
      "type":"string",
      "required":true,
      "description":"serial port of connected device (e.g. '/dev/ttyACM0')",
      "enum":["No port available"]
    },
    "baud":{
      "type":"number",
      "required":true,
      "enum":[300, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 74880, 115200, 230400, 250000, 500000, 1000000, 2000000]
    }
  }

  /** list of available midi ports */
  this.midi_ports = ["No port available"]

  /** settings scheme for midi {@link midi.js} devices or tools*/
  this.midi = {
    "input_port":{
      "type":"string",
      "required":true,
      "enum": this.midi_ports
    },
    "output_port":{
      "type":"string",
      "required":true,
      "enum": this.midi_ports
    },
    "channel":{
      "description":"set a default midi channel for in and out. 0 allows any channel. You can always change it per message",
      "type":"integer",
      "required":true,
      "default":0,
      "maximum":16,
      "minimum":0,
      "enum":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]
    }
  }

  this.getDevice = function(data) {
    //console.log("Available Ports: ")
    //console.log(this[data.interface.toLowerCase()].port.enum)
    let new_device = this.device
    new_device.properties.settings.properties = this[data.interface.toLowerCase()]
    return(new_device)
  }

  /**
  * Scheme for creating a new HTTP Device
  * Following Properties will be added by default.
  * For HTTP Device
  * "url":{"type":"string","description":""}
  * For ALL
  * "name"{"type":"string","description":"name the device to identify it when you create a Cue"}
  */
  this.device = {
    "type":"object",
    "title":"|",
    "properties":{
      "interface":{
        "type":"string",
        "title":"Interface protocol",
        "descripton":"Set the communication protocol the device uses",
        "required":true,
        "enum":["HTTP","TCP","UDP", "OSC","SERIAL", "MIDI"]
      },
      "settings":{
        "type":"object",
        "description":"set the connection properties for this device",
        "required":true,
        "properties":this.http
      },
      "properties":this.metaSchema,
      "stencil": {
        "type":"string",
        "readonly":true,
        "description":"Properties template the device is based on. Update Stencil to change properties for all devices based on this stencil."
      },
      "name": {
        "type":"string",
        "required":true,
        "description":"Device Name. Can be changed in title on top of page.",
        "readonly":true
      },
      "_id": {
        "type":"string",
        "readonly":true,
        "description":"auto created unique identification"
      }
    }
  }

  /**
  * Default Device Templates (stencils)
  */
  this.stencils = {}

  this.stencils.empty = {
    "properties":{}
  }

  this.midi_values = function() {
    let values = []
    for(let i = 0; i&lt;128; i++) {
      values.push(i)
    }
    return values
  }

  this.stencils.midi_device = {
    "properties":{
      "channel":{
        "description":"set a midi channel for this message. If none, the default device channel is used.",
        "type":"integer",
        "maximum":16,
        "minimum":1,
        "enum":[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]
      },
      "note":{
        "type":"string",
        "description":"specify pitch and velocity seperated by blank e.g. '22 15'"
      },
      "pitch":{
        "type":"integer",
        "maximum":127,
        "minimum":0
        //"enum":this.midi_values()
      },
      "velocity":{
        "type":"integer",
        "maximum":127,
        "minimum":0
        //"enum":this.midi_values()
      }
    }
  }

  /** dafault scheme to modify player/status entries. Status item exists by Default
  * and has only 1 instance
  * Will add:
  * "title":"status"
  */
  this.status = {
    "type":"object",
    "properties":{
      "type":"object",
      "required":true
    }
  }
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="Collection.html">Collection</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Level.html">Level</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Schemes.html">Schemes</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Sessions.html">Sessions</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#schemes">schemes</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Sun Dec 15 2019 13:33:44 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
